#pragma once

#include "config.h"
#include "../resource.h"

//====================================
// CAB̐ݒ荀
//====================================
class CConfigCAB : public CDialogImpl<CConfigCAB>,public CMessageFilter
{
protected:
	CConfigManager	&Config;

	CButton			Radio_CompressType[CAB_COMPRESS_TYPE_MAX_NUM];
	CEdit			Edit_LZX_Level;
	CTrackBarCtrl	Track_LZX_Level;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_CAB };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigCAB)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_HSCROLL(OnHScroll)
		COMMAND_RANGE_HANDLER(IDC_RADIO_CAB_MSZIP,IDC_RADIO_CAB_PLAIN, OnRadioCompressType)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	void OnHScroll(int, short, HWND);
	LRESULT OnRadioCompressType(WORD,WORD,HWND,BOOL&);

	CConfigCAB(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE(_T("CConfigCAB()\n"));
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

