#pragma once
#include "config.h"
#include "../resource.h"
#include <atlddx.h>		// DDX/DDVgp邽

//====================================
// ʐݒ荀
//====================================
class CConfigGeneral : public CDialogImpl<CConfigGeneral>,public CMessageFilter,public CWinDataExchange<CConfigGeneral>
{
protected:
	CConfigManager	&Config;
	CButton Radio_LostDir[LOSTDIR_MAX_NUM];
	CButton Radio_LogView[LOGVIEW_MAX_NUM];

	CButton Check_UseFiler;
	CEdit Edit_FilerPath;
	CEdit Edit_FilerParam;
	CButton Button_BrowseFiler;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnCheckFiler(WORD,WORD,HWND,BOOL&);
	LRESULT OnBrowseFiler(WORD,WORD,HWND,BOOL&);
public:
	enum { IDD = IDD_PROPPAGE_CONFIG_GENERAL };
	// DDX}bv
	BEGIN_DDX_MAP(CConfigGeneral)
		DDX_CHECK(IDC_CHECK_WARN_NETWORK,Config.Common.WarnNetwork)
		DDX_CHECK(IDC_CHECK_WARN_REMOVABLE,Config.Common.WarnRemovable)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigGeneral)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER(IDC_CHECK_USE_FILER,OnCheckFiler)
		COMMAND_ID_HANDLER(IDC_BUTTON_BROWSE_FILER,OnBrowseFiler)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnApply();

	CConfigGeneral(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE(_T("CConfigGeneral()\n"));
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

};

