#include "common.h"
#include "config_zip.h"

//=================
// ZIPʐݒ
//=================
LRESULT CConfigZIP::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);
	//----------------
	// k`̑I
	//----------------
	Radio_CompressType[ZIP_COMPRESS_DEFLATE]=GetDlgItem(IDC_RADIO_ZIP_DEFLATE);
	Radio_CompressType[ZIP_COMPRESS_DEFLATE64]=GetDlgItem(IDC_RADIO_ZIP_DEFLATE64);
	Radio_CompressType[ZIP_COMPRESS_BZIP2]=GetDlgItem(IDC_RADIO_ZIP_BZIP2);
	Radio_CompressType[ZIP_COMPRESS_COPY]=GetDlgItem(IDC_RADIO_ZIP_COPY);

	Radio_CompressType[Config.ZIP.CompressType].SetCheck(1);

	//------------------
	// kx̑I
	//------------------
	Radio_CompressLevel[ZIP_COMPRESS_LEVEL0]=GetDlgItem(IDC_RADIO_ZIP_COMPRESS_LEVEL_0);
	Radio_CompressLevel[ZIP_COMPRESS_LEVEL5]=GetDlgItem(IDC_RADIO_ZIP_COMPRESS_LEVEL_5);
	Radio_CompressLevel[ZIP_COMPRESS_LEVEL9]=GetDlgItem(IDC_RADIO_ZIP_COMPRESS_LEVEL_9);

	Radio_CompressLevel[Config.ZIP.CompressLevel].SetCheck(1);


	//---------------
	// Deflate̐ݒ
	//---------------
	//TCY
	::SendMessage(GetDlgItem(IDC_EDIT_ZIP_DEFLATE_MEMORY_SIZE),EM_LIMITTEXT,3,NULL);
	Check_SpecifyDeflateMemorySize=GetDlgItem(IDC_CHECK_ZIP_SPECIFY_MEMORY_SIZE);
	Check_SpecifyDeflateMemorySize.SetCheck(Config.ZIP.SpecifyDeflateMemorySize);
	::EnableWindow(GetDlgItem(IDC_EDIT_ZIP_DEFLATE_MEMORY_SIZE),Config.ZIP.SpecifyDeflateMemorySize);
	DeflateMemorySize=Config.ZIP.DeflateMemorySize;
	//pX
	::SendMessage(GetDlgItem(IDC_EDIT_ZIP_DEFLATE_PASS_NUMBER),EM_LIMITTEXT,1,NULL);
	Check_SpecifyDeflatePassNumber=GetDlgItem(IDC_CHECK_ZIP_SPECIFY_PASS_NUMBER);
	Check_SpecifyDeflatePassNumber.SetCheck(Config.ZIP.SpecifyDeflatePassNumber);
	::EnableWindow(GetDlgItem(IDC_EDIT_ZIP_DEFLATE_PASS_NUMBER),Config.ZIP.SpecifyDeflatePassNumber);
	DeflatePassNumber=Config.ZIP.DeflatePassNumber;


	//DDXAbvf[g
	DoDataExchange(FALSE);

	return TRUE;
}

LRESULT CConfigZIP::OnApply()
{
//===============================
// ݒConfigManagerɏ߂
//===============================
	//----------------
	// k`̑I
	//----------------
	for(int Type=0;Type<ZIP_COMPRESS_TYPE_MAX_NUM;Type++){
		if(Radio_CompressType[Type].GetCheck()){
			Config.ZIP.CompressType=(ZIP_COMPRESS_TYPE)Type;
			break;
		}
	}

	//------------------
	// kx̑I
	//------------------
	for(int Type=0;Type<ZIP_COMPRESS_LEVEL_MAX_NUM;Type++){
		if(Radio_CompressLevel[Type].GetCheck()){
			Config.ZIP.CompressLevel=(ZIP_COMPRESS_LEVEL)Type;
			break;
		}
	}

	//---------------
	// DDXf[^XV
	//---------------
	if(!DoDataExchange(TRUE)){
		return FALSE;
	}
	//---------------
	// Deflate̐ݒ
	//---------------
	//TCY
	Config.ZIP.SpecifyDeflateMemorySize=Check_SpecifyDeflateMemorySize.GetCheck();
	Config.ZIP.DeflateMemorySize=DeflateMemorySize;
	//pX
	Config.ZIP.SpecifyDeflatePassNumber=Check_SpecifyDeflatePassNumber.GetCheck();
	Config.ZIP.DeflatePassNumber=DeflatePassNumber;
	return TRUE;
}

LRESULT CConfigZIP::OnSpecifyDeflateMemorySize(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		::EnableWindow(GetDlgItem(IDC_EDIT_ZIP_DEFLATE_MEMORY_SIZE),Check_SpecifyDeflateMemorySize.GetCheck());
	}
	return 0;
}

LRESULT CConfigZIP::OnSpecifyDeflatePassNumber(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		::EnableWindow(GetDlgItem(IDC_EDIT_ZIP_DEFLATE_PASS_NUMBER),Check_SpecifyDeflatePassNumber.GetCheck());
	}
	return 0;
}

